<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>RequestOtpService.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">astrapay-otp</a> &gt; <a href="index.source.html" class="el_package">com.astrapay.otp.service</a> &gt; <span class="el_source">RequestOtpService.java</span></div><h1>RequestOtpService.java</h1><pre class="source lang-java linenums">package com.astrapay.otp.service;

import com.astrapay.otp.config.ServiceResponse;
import com.astrapay.otp.domain.request.RequestOtpRequest;
import com.astrapay.otp.domain.request.ValidateOtpRequest;
import com.astrapay.otp.domain.response.RequestOtpResponse;
import com.astrapay.otp.model.ConfigOtp;
import com.astrapay.otp.model.RequestOtp;
import com.astrapay.otp.repository.ConfigOtpRepository;
import com.astrapay.otp.repository.RequestOtpRepository;
import com.astrapay.otp.util.Decryptor;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.google.gson.Gson;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Map;
import java.util.Random;

@Service
public class RequestOtpService {
<span class="fc" id="L30">    private final Logger log = LoggerFactory.getLogger(this.getClass());</span>

    private final RequestOtpRepository requestOtpRepository;
    private final ConfigOtpRepository configOtpRepository;
    private final SmsService smsService;
<span class="fc" id="L35">    private Random rnd = new Random();</span>

<span class="fc" id="L37">    public RequestOtpService(RequestOtpRepository requestOtpRepository, ConfigOtpRepository configOtpRepository, SmsService smsService) {</span>
<span class="fc" id="L38">        this.requestOtpRepository = requestOtpRepository;</span>
<span class="fc" id="L39">        this.configOtpRepository = configOtpRepository;</span>
<span class="fc" id="L40">        this.smsService = smsService;</span>
<span class="fc" id="L41">    }</span>

    @Value(&quot;${service-sms-url}&quot;)
    private String urlOtp;
    @Value(&quot;${maximum-verify}&quot;)
    private int maximumVerify;
    @Value(&quot;${encrypt-key.secret_key}&quot;)
    public String secretKeys;
    @Value(&quot;${encrypt-key.salt}&quot;)
    public String salt;

    public RequestOtpResponse requestOtp(String data) {
<span class="nc" id="L53">        Decryptor decryptor = new Decryptor();</span>
<span class="nc" id="L54">        Gson gson = new Gson();</span>
<span class="nc" id="L55">        String requestDecrypted = decryptor.decrypt(data,secretKeys,salt);</span>
<span class="nc" id="L56">        JsonObject jsonObject = new JsonParser().parse(requestDecrypted.replaceAll(&quot;/(\&quot;[^\&quot;]*\&quot;)|\\s/g&quot;, &quot;&quot;)).getAsJsonObject();</span>
<span class="nc" id="L57">        RequestOtpRequest request = gson.fromJson(jsonObject.getAsJsonObject(), RequestOtpRequest.class);</span>
<span class="nc" id="L58">        RequestOtpResponse response = new RequestOtpResponse();</span>
<span class="nc" id="L59">        ServiceResponse serviceResponse = new ServiceResponse();</span>
<span class="nc" id="L60">        int randomReqCode = rnd.nextInt(999999);</span>
<span class="nc" id="L61">        int randomOtp = rnd.nextInt(999999);</span>
<span class="nc" id="L62">        SimpleDateFormat sdformat = new SimpleDateFormat(&quot;yyyy-MM-dd HH:mm&quot;);</span>
<span class="nc" id="L63">        Date requestTime = new Date();</span>
<span class="nc" id="L64">        Date expireTime = new Date();</span>
<span class="nc" id="L65">        Calendar nowForReqTime = Calendar.getInstance();</span>
<span class="nc" id="L66">        Calendar nowForExpTime = Calendar.getInstance();</span>
        try {
<span class="nc" id="L68">            RequestOtp newOtp = new RequestOtp();</span>
<span class="nc" id="L69">            newOtp.setPhoneNumber(request.getPhoneNumber());</span>
<span class="nc" id="L70">            newOtp.setOtp(String.format(&quot;%06d&quot;, randomOtp));</span>
<span class="nc" id="L71">            newOtp.setReqCode(String.format(&quot;%06d&quot;, randomReqCode));</span>
<span class="nc" id="L72">            ConfigOtp dataConfig = configOtpRepository.findByReqType(request.getReqType());</span>
<span class="nc" id="L73">            String message = &quot;&quot;;</span>
<span class="nc bnc" id="L74" title="All 2 branches missed.">            if (dataConfig != null) {</span>
<span class="nc" id="L75">                newOtp.setReqType(request.getReqType());</span>
<span class="nc" id="L76">                nowForExpTime.add(Calendar.MINUTE, dataConfig.getTimeExpired());</span>
<span class="nc" id="L77">                message = dataConfig.getMessage();</span>
            } else {
<span class="nc" id="L79">                log.error(&quot;Type Req Not Exist&quot;);</span>
<span class="nc" id="L80">                response.setServiceResponse(serviceResponse.failTypeOtp(serviceResponse));</span>
            }
<span class="nc" id="L82">            Date forReqTime = nowForReqTime.getTime();</span>
<span class="nc" id="L83">            Date forExpTime = nowForExpTime.getTime();</span>
<span class="nc" id="L84">            String requestTimeStr = sdformat.format(forReqTime);</span>
<span class="nc" id="L85">            String expireTimeStr = sdformat.format(forExpTime);</span>
            try {
<span class="nc" id="L87">                requestTime = sdformat.parse(requestTimeStr);</span>
<span class="nc" id="L88">                expireTime = sdformat.parse(expireTimeStr);</span>
<span class="nc" id="L89">            } catch (ParseException pe) {</span>
<span class="nc" id="L90">                log.error(pe.getMessage());</span>
<span class="nc" id="L91">            }</span>
<span class="nc" id="L92">            newOtp.setRequestTime(requestTime);</span>
<span class="nc" id="L93">            newOtp.setExpiredTime(expireTime);</span>
            //send sms disini sama kasih if sukses do dibawah ini
<span class="nc" id="L95">            Map&lt;String, String&gt; resp = smsService.sendSms(request.getPhoneNumber(), String.format(&quot;%06d&quot;, randomOtp), message);</span>
<span class="nc" id="L96">            String smsResp = gson.toJson(resp);</span>
<span class="nc" id="L97">            log.info(smsResp);</span>
<span class="nc bnc" id="L98" title="All 2 branches missed.">            if (resp.get(&quot;Status&quot;).equals(&quot;1&quot;)) {</span>
<span class="nc" id="L99">                requestOtpRepository.save(newOtp);</span>
<span class="nc" id="L100">                response.setServiceResponse(serviceResponse.successRequestOtp(serviceResponse));</span>
<span class="nc" id="L101">                response.setReqCode(newOtp.getReqCode());</span>
<span class="nc" id="L102">                String gsonResponse = gson.toJson(response);</span>
<span class="nc" id="L103">                log.info(&quot;Resp :&quot;);</span>
<span class="nc" id="L104">                log.info(gsonResponse);</span>
<span class="nc" id="L105">            }else{</span>
<span class="nc" id="L106">                response.setServiceResponse(serviceResponse.failRequestSms(serviceResponse));</span>
<span class="nc" id="L107">                log.error(&quot;SMS GAGAL&quot;);</span>
            }
<span class="nc" id="L109">            ObjectMapper object = new ObjectMapper();</span>
<span class="nc" id="L110">            String jsonString = object.writeValueAsString(response);</span>

<span class="nc" id="L112">        } catch (Exception e) {</span>
<span class="nc" id="L113">            log.error(e.getMessage());</span>
<span class="nc" id="L114">            response.setServiceResponse(serviceResponse.failRequestOtp(serviceResponse));</span>
<span class="nc" id="L115">        }</span>
<span class="nc" id="L116">        return response;</span>
    }

    public ServiceResponse validateOtp(String data) {
<span class="nc" id="L120">        Decryptor decryptor = new Decryptor();</span>
<span class="nc" id="L121">        Gson gson = new Gson();</span>
<span class="nc" id="L122">        String requestDecrypted = decryptor.decrypt(data,secretKeys,salt);</span>
<span class="nc" id="L123">        JsonObject jsonObject = new JsonParser().parse(requestDecrypted.replaceAll(&quot;/(\&quot;[^\&quot;]*\&quot;)|\\s/g&quot;, &quot;&quot;)).getAsJsonObject();</span>
<span class="nc" id="L124">        ValidateOtpRequest request = gson.fromJson(jsonObject.getAsJsonObject(), ValidateOtpRequest.class);</span>
<span class="nc" id="L125">        ServiceResponse serviceResponse = new ServiceResponse();</span>
<span class="nc" id="L126">        SimpleDateFormat sdformat = new SimpleDateFormat(&quot;yyyy-MM-dd HH:mm&quot;);</span>
<span class="nc" id="L127">        Date requestTime = new Date();</span>
<span class="nc" id="L128">        Date validateTime = new Date();</span>
        try {
<span class="nc" id="L130">            RequestOtp dataOtp = requestOtpRepository.findLastOtp(request.getPhoneNumber(), request.getReqCode());</span>
<span class="nc bnc" id="L131" title="All 2 branches missed.">            if (!dataOtp.isUsed()) {</span>
<span class="nc" id="L132">                String requestTimeStr = sdformat.format(dataOtp.getExpiredTime());</span>
<span class="nc" id="L133">                String validateTimeStr = sdformat.format(new Date());</span>
<span class="nc" id="L134">                dataOtp.setVerifyCounter(dataOtp.getVerifyCounter()+1);</span>
                try {
<span class="nc" id="L136">                    requestTime = sdformat.parse(requestTimeStr);</span>
<span class="nc" id="L137">                    validateTime = sdformat.parse(validateTimeStr);</span>
<span class="nc" id="L138">                } catch (ParseException pe) {</span>
<span class="nc" id="L139">                    log.error(pe.getMessage());</span>
<span class="nc" id="L140">                    serviceResponse.failParsing(serviceResponse);</span>
<span class="nc" id="L141">                }</span>
<span class="nc bnc" id="L142" title="All 2 branches missed.">                if (validateTime.compareTo(requestTime) &gt; 0) {</span>
<span class="nc" id="L143">                    log.error(&quot;OTP Expire&quot;);</span>
<span class="nc" id="L144">                    serviceResponse.failExpireOtp(serviceResponse);</span>
<span class="nc bnc" id="L145" title="All 4 branches missed.">                } else if (validateTime.compareTo(requestTime) &lt; 0 &amp;&amp; dataOtp.getOtp().equals(request.getOtp())) {</span>
<span class="nc" id="L146">                    log.info(&quot;OTP Match &amp; Success&quot;);</span>
<span class="nc" id="L147">                    dataOtp.setUsed(true);</span>
<span class="nc" id="L148">                    requestOtpRepository.save(dataOtp);</span>
<span class="nc" id="L149">                    serviceResponse.successValidateOtp(serviceResponse);</span>
                }else{
<span class="nc" id="L151">                    log.error(&quot;OTP Dont Match / Doesnt Exist&quot;);</span>
<span class="nc bnc" id="L152" title="All 2 branches missed.">                    if(dataOtp.getVerifyCounter() &gt;= maximumVerify){</span>
<span class="nc" id="L153">                        dataOtp.setUsed(true);</span>
                    }
<span class="nc" id="L155">                    requestOtpRepository.save(dataOtp);</span>
<span class="nc" id="L156">                    serviceResponse.failValidateOtp(serviceResponse);</span>
                }
<span class="nc" id="L158">            } else {</span>
<span class="nc" id="L159">                log.error(&quot;OTP Used&quot;);</span>
<span class="nc" id="L160">                serviceResponse.failUsedOtp(serviceResponse);</span>
            }
<span class="nc" id="L162">        } catch (Exception e) {</span>
<span class="nc" id="L163">            log.error(e.getMessage());</span>
<span class="nc" id="L164">            serviceResponse.failValidateOtp(serviceResponse);</span>
<span class="nc" id="L165">        }</span>
<span class="nc" id="L166">        return serviceResponse;</span>
    }

    public String encryptRequest(Object request) {
        try {
<span class="nc" id="L171">            Decryptor decryptor = new Decryptor();</span>
<span class="nc" id="L172">            ObjectMapper object = new ObjectMapper();</span>
<span class="nc" id="L173">            String jsonString = object.writeValueAsString(request);</span>
<span class="nc" id="L174">            return decryptor.encrypt(jsonString,secretKeys,salt);</span>
<span class="nc" id="L175">        } catch (Exception e) {</span>
<span class="nc" id="L176">            log.error(e.getMessage());</span>
<span class="nc" id="L177">            return &quot;error&quot;;</span>
        }
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.5.201910111838</span></div></body></html>